"use strict";

var _this = void 0;

var getDepPath = require('./getDepPath');

module.exports = function (options) {
  var source = '';

  if (options.isMultiPageWebApp) {
    source = "\n    import definedApp from '" + options.definedAppPath + "';\n    import { render, createElement } from '" + options.renderModule + "';\n    import Component from '" + getDepPath(options.routes[options.routeIndex].component, _this.rootContext) + "';\n    import DriverUniversal from 'driver-universal';\n    " + options.importMods + "\n    \n    const withSSR = !!window.__INITIAL_DATA__;\n\n    " + "\n    const appProps = {\n      Component,\n    };\n    \n    function Entry() {\n      const app = definedApp(appProps);\n      return app;\n    }\n    \n    " + options.appRender + "\n  ";
  } else {
    source = "\n    import definedApp from '" + options.definedAppPath + "';\n    import { render, createElement } from '" + options.renderModule + "';\n    import { " + options.historyMemory + " as createHistory } from 'history';\n    import { _invokeAppCycle } from 'universal-app-runtime';\n    import DriverUniversal from 'driver-universal';\n    " + options.importMods + "\n    \n    const interopRequire = (mod) => mod && mod.__esModule ? mod.default : mod;\n    const withSSR = !!window.__INITIAL_DATA__;\n    \n    const getRouterConfig = () => {\n      const routes = [];\n      " + options.assembleRoutes + "\n      return {\n        history: createHistory(),\n        routes,\n      };\n    };\n\n    " + "\n    const appProps = {\n      routerConfig: getRouterConfig(),\n    };\n    \n    let appLaunched = false;\n    \n    function Entry() {\n      const app = definedApp(appProps);\n      const startOptions = {};\n\n      if (!appLaunched) {\n        appLaunched = true;\n        _invokeAppCycle('launch', startOptions);\n      }\n\n      return app;\n    }\n    \n    " + options.appRender + "\n  ";
  }

  return source;
};